/**
 * Copyright (c) 2013-2017 Linagora
 * 
 * This program/library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or (at your
 * option) any later version.
 * 
 * This program/library is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
 * FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program/library; If not, see http://www.gnu.org/licenses/
 * for the GNU Lesser General Public License version 2.1.
 */
package org.ow2.petals.cli.extension.command.monitoring.so.components.bc.soap;

import java.util.Arrays;
import java.util.List;

import org.ow2.petals.cli.extension.command.monitoring.so.api.EmittableDefect;
import org.ow2.petals.cli.extension.command.monitoring.so.api.SubscriptionObject;
import org.ow2.petals.cli.extension.command.monitoring.so.components.framework.AbstractMonitoredComponent;

/**
 * The subscription object associated to the Petals BC SOAP
 * 
 * @author Christophe DENEUX - Linagora
 * 
 */
public class BcSoap extends AbstractMonitoredComponent implements SubscriptionObject {

    private final static String NAME = "petals-bc-soap";

    private final static String DESCRIPTION = "Subscription to the defects of the Petals BC SOAP";

    private final static EmittableDefect[] EMITTABLE_DEFECTS = new EmittableDefect[] {
            new NoMoreThreadInHttpThreadPool(), new NoMoreWsClientsInPool() };

    @Override
    public String getName() {
        return NAME;
    }

    @Override
    public String getDescription() {
        return DESCRIPTION;
    }

    @Override
    public List<EmittableDefect> getDedicatedEmittableDefects() {
        return Arrays.asList(BcSoap.EMITTABLE_DEFECTS);
    }

}
